/*
 * TurtleDraw.h
 *
 * Copyright (C) 2003 mikesag
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * ------------------------------------------------------------------------------ *
 *
 * This file and the corresponding .cpp file implement turtle drawing as was
 * was used on Logo or BASIC back in the 80's.
 *
 * The turtle engine was written from scratch, but the glyphs themselves are
 * from Walter Pullen's Astrolog, relicensed by permission under the GNU GPL.
 * I'd like to thank him for his inspiration in creating such a high-quality
 * free astrology program!
 *
 * Parts Copyright (C) Walter D. Pullen, 1991-1998
 * Rest Copyright (C) mikesag 2003
 *
 */

#ifndef __TURTLEDRAW_H__
#define __TURTLEDRAW_H__

#define TURTLE_DRAW_ASCII 20750
#define TURTLE_NUMBER     16

#define SMALL_GLYPH_H     10
#define SMALL_GLYPH_W     10

#define LARGE_GLYPH_H     20
#define LARGE_GLYPH_W     20

#define RIGHT_ARROW_CHAR  97

void InitializeTurtle();
void TurtleDraw(const wxString &commands, wxDC *dc, int x, int y, int scale = 1);

void DrawSign(int n, wxDC *dc, int x, int y, int scale = 1);
void DrawHouse(int n, wxDC *dc, int x, int y, int scale = 1);
void DrawAspect(int n, wxDC *dc, int x, int y, int scale = 1);
void DrawObject(int n, wxDC *dc, int x, int y, int scale = 1);
void DrawChar(int n, wxDC *dc, int x, int y, int scale = 1);

/* This is the only function that should have to be called directly */
void DrawGlyph(int n, wxDC *dc, int x, int y, int scale = 1);

/* Utility function to help when custom colors haven't been selected */
wxColour DefaultObjectColour(int colConst, unsigned char intensity); /* input is colXXX
                                                           from Translation.h */
wxColour DefaultAspectColour(int n, unsigned char intensity); /* AstroConst.h format */

#endif
