/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This program demonstrates the use of the insertion sort algorithm.  For
 * more information about this and other sorting algorithms, see
 * http://linux.wku.edu/~lamonml/kb.html
 *
 */

#include <stdlib.h>
#include <stdio.h>

#define NUM_ITEMS 1000

void insertionSort(long int numbers[], long int array_size);

long int numbers[NUM_ITEMS];

inline long int notzero(long int n)
{
	return (n != 0) ? n : 1;
}

int main()
{
  long int i;

  //seed random number generator
  srand(getpid());

  //fill array with random integers
  for (i = 0; i < NUM_ITEMS; i++)
    numbers[i] = notzero(rand())*notzero(rand());

  //perform insertion sort on array
  insertionSort(numbers, NUM_ITEMS);

  printf("Done with sort.\n");

  for (i = 0; i < 20; i++)
    printf("%li\n", numbers[i]);
  printf("...\n");
  for (i = NUM_ITEMS - 20; i < NUM_ITEMS; i++)
    printf("%li\n", numbers[i]);

}


void insertionSort(long int numbers[], long int array_size)
{
  long int i, j, index;

  for (i=1; i < array_size; i++)
  {
    index = numbers[i];
    j = i;
    while ((j > 0) && (numbers[j-1] > index))
    {
      numbers[j] = numbers[j-1];
      j = j - 1;
    }
    numbers[j] = index;
  }
}


